/*!
 * Native Javascript Library
 * v1.0.2 (2019-11-13)
 * 新增登录和分享接口
 * v1.0.3 (2019-11-14)
 * 新增rsa加密算法
 * v1.0.4 (2019-11-16)
 * 新增打开文件接口
 * v1.0.5 (2019-11-16)
 * 新增退出登录接口
 * v1.0.6 (2019-11-19)
 * 新增打开网页接口
 * v1.0.7 (2019-11-20)
 * 修改判断android手机和iOS手机的逻辑
 * v1.0.8 (2019-12-12)
 * iOS适配WKWebView
 * v1.0.9 (2020-05-06)
 * 默认使用WKWebView
 * v1.0.10 (2020-05-14)
 * 新增记录日志方法
 * v1.0.11 (2020-07-14)
 * 新增打开文件和分享功能
 * v1.0.12（2020-07-15）
 * 新增打开超链接的分享功能
 * v1.0.13（2020-08-19）
 * 新增是否支持生物识别、是否设置生物识别、是否设置手势登录、设置手势开关、设置生物识别开关、修改手势密码、显示或隐藏悬浮按钮、拖动验证码匹配成功回调、版本信息、获取缓存大小、埋点
 */
(function(window) {
    /**
     * android系统
     */
    function Android() {
        this.toast = function(text) {
            android.toast(text);
        }
        this.finish = function() {
            android.finish();
        }
        this.showInputMethod = function() {
            android.showInputMethod();
        }
        this.hiddenInputMethod = function() {
            android.hiddenInputMethod();
        }
        this.hasNetWork = function() {
            return android.hasNetWork();
        }
        this.href = function(tag, path) {
            android.href(tag, path);
        }
        this.open = function(params) {
            android.open(JSON.stringify(params));
        }
        this.html = function(url, title, shareEnabled) {
            try {
                android.html(url, title, shareEnabled);
            } catch (e) {
                android.html(url, title);
            }
        }
        this.callPhone = function(phone) {
            android.callPhone(phone);
        }
        this.copy = function(text) {
            android.copy(text);
        }
        this.setItem = function(key, value) {
            android.setItem(key,value);
        }
        this.getItem = function(key) {
            return android.getItem(key);
        }
        this.removeItem = function(key) {
            android.removeItem(key);
        }
        this.login = function(callback) {
            android.login(callback);
        }
        this.logout = function() {
            android.logout();
        }
        this.share = function(url, title, description) {
            android.share(url, title, description);
        }
        this.clearCache = function(callback) {
            android.clearCache(callback);
        }
        this.getCacheSize = function() {
            return android.getCacheSize();
        }
        this.rsa = function(text) {
            return android.rsa(text);
        }
        this.aes = function(text) {
            return android.aesEncrypt(text);
        }
        this.log = function(text) {
            android.log(text);
        }
        this.isSupportBiometric = function() {
            return android.isSupportBiometric();
        }
        this.isBiometricEnable = function() {
            return android.isBiometricEnable();
        }
        this.isEnabledGesture = function() {
            return android.isEnabledGesture();
        }
        this.setGestureEnable = function(enable, callback, cb) {
            window[callback] = function(flag) {
                window[callback] = null;
                cb(flag);
            };
            android.setGestureEnable(enable, callback);
        }
        this.setBiometricEnable = function(enable, callback) {
            android.setBiometricEnable(enable, callback);
        }
        this.gestureModify = function() {
            android.gestureModify();
        }
        this.tdPropertyPoint = function(eventId, eventLabel) {
            android.tdPropertyPoint(eventId, eventLabel);
        }
        this.tdEventPoint = function(eventId, eventLabel) {
            android.tdEventPoint(eventId, eventLabel);
        }
        this.back = function (callback) {
            if (callback) {
                android.back(callback);
            } else {
                android.back();
            }
        }
        this.suspensionView = function (isShow) {
            if (isShow) {
                android.showSuspensionView();
            } else {
                android.hiddenSuspensionView();
            }
        }
        this.validationSuccess = function (data) {
            android.validationSuccess(data);
        }
        this.version = function () {
            return android.version();
        }
    }

    /**
     * iOS系统WKWebView
     */
    function iOSWKWebView() {
        this.toast = function(text) {
            prompt("xcode-oc:toast", text);
        }
        this.finish = function() {
            prompt("xcode-oc:finish");
        }
        this.showInputMethod = function() {
            // do nothing
        }
        this.hiddenInputMethod = function() {
            // do nothing
        }
        this.hasNetWork = function() {
            return prompt("xcode-oc:hasNetWork") == "YES";
        }
        this.href = function(tag, path) {
            var json = {};
            json.tag = tag;
            json.path = path;
            prompt("xcode-oc:href", JSON.stringify(json));
        }
        this.open = function(params) {
            prompt("xcode-oc:open", JSON.stringify(params));
        }
        this.html = function(url, title, shareEnabled) {
            var json = {};
            json.url = url;
            json.title = title;
            json.shareEnabled = shareEnabled;
            prompt("xcode-oc:html", JSON.stringify(json));
        }
        this.callPhone = function(phone) {
            prompt("xcode-oc:callPhone", phone);
        }
        this.copy = function(text) {
            prompt("xcode-oc:copy", text);
        }
        this.setItem = function(key, value) {
            var json = {};
            json.key = key;
            json.value = value;
            prompt("xcode-oc:setItem", JSON.stringify(json));
        }
        this.getItem = function(key) {
            return prompt("xcode-oc:getItem", key);
        }
        this.removeItem = function(key) {
            prompt("xcode-oc:removeItem", key);
        }
        this.login = function(callback) {
            prompt("xcode-oc:login", callback);
        }
        this.logout = function() {
            prompt("xcode-oc:logout");
        }
        this.share = function(url, title, description) {
            var json = {};
            json.url = url;
            json.title = title;
            json.description = description;
            prompt("xcode-oc:share", JSON.stringify(json));
        }
        this.clearCache = function(callback) {
            prompt("xcode-oc:iOSClearCache", callback);
        }
        this.getCacheSize = function() {
            return prompt("xcode-oc:iOSGetCacheSize");
        }
        this.rsa = function(text) {
            return prompt("xcode-oc:rsa", text);
        }
        this.aes = function(text) {
            return prompt("xcode-oc:iOSAES", text);
        }
        this.log = function(text) {
            prompt("xcode-oc:log", text);
        }
        this.isSupportBiometric = function() {
            return prompt("xcode-oc:iOSIsSupportBiometric") === 'YES';
        }
        this.isBiometricEnable = function() {
            return prompt("xcode-oc:iOSIsBiometricEnable") === 'YES';
        }
        this.isEnabledGesture = function() {
            return prompt("xcode-oc:iOSIsEnabledGesture") === 'YES';
        }
        this.setGestureEnable = function(enable, callback, cb) {
            window[callback] = function(flag) {
                window[callback] = null;
                cb(flag === 'YES');
            };
            prompt("xcode-oc:iOSSetGestureEnable", JSON.stringify({
                value: enable ? 'YES' : 'NO',
                callback: callback
            }));
        }
        this.setBiometricEnable = function(enable, callback) {
            prompt("xcode-oc:iOSSetBiometricEnable", JSON.stringify({
                value: enable,
                callback: callback
            }));
        }
        this.gestureModify = function() {
            prompt("xcode-oc:iOSGestureModify");
        }
        this.tdPropertyPoint = function(eventId, eventLabel) {
            prompt("xcode-oc:iOSTDPropertyPoint", JSON.stringify({
                eventId: eventId,
                eventLabel: eventLabel
            }));
        }
        this.tdEventPoint = function(eventId, eventLabel) {
            prompt("xcode-oc:iOSTDEventPoint", JSON.stringify({
                eventId: eventId,
                eventLabel: eventLabel
            }));
        }
        this.back = function (callback) {
            if (callback) {
                prompt("xcode-oc:iOSBack", callback);
            } else {
                prompt("xcode-oc:iOSBack")
            }
        }
        this.suspensionView = function (isShow) {
            if (isShow) {
                prompt("xcode-oc:iOSShowSuspensionView");
            } else {
                prompt("xcode-oc:iOSHiddenSuspensionView")
            }
        }
        this.validationSuccess = function (data) {
            prompt("xcode-oc:validationSuccess", data);
        }
        this.version = function () {
            return prompt("xcode-oc:iOSVersion");
        }
    }

    /**
     * UI组件
     */
    function UI(wrapper) {

        /**
         * 显示toast
         */
        this.toast = function(text) {
            wrapper.toast(text);
        }

        /**
         * 关闭当前界面
         */
        this.finish = function() {
            wrapper.finish();
        }

        /**
         * 显示输入法，iOS不支持
         */
        this.showInputMethod = function() {
            wrapper.showInputMethod();
        }

        /**
         * 隐藏输入法，iOS不支持
         */
        this.hiddenInputMethod = function() {
            wrapper.hiddenInputMethod();
        }

        /**
         * 返回  关闭view
         */
        this.back = function(callback) {
            wrapper.back(callback);
        }
        /**
         * 版本信息  marketingVersion当前版本 hasNewVersion是否有更新
         */
        this.version = function () {
            return JSON.parse(wrapper.version());
        }
    }

    /**
     * 网络组件
     */
    function Net(wrapper) {

        /**
         * 是否有网络
         */
        this.hasNetWork = function() {
            return wrapper.hasNetWork();
        }
    }

    /**
     * 文件组件
     */
    function File(wrapper) {

        /**
         * 跳转轻应用指定页面
         */
        this.href = function(tag, path) {
            wrapper.href(tag, path);
        }

        /**
         * 打开附件
         * @param {string}  params url 附件下载地址
         * @param {string}  params title 页面标题
         */
        this.open = function(params) {
            wrapper.open(params);
        }

        /**
          * 打开html的网页
          */
        this.html = function(url, title, shareEnabled) {
            wrapper.html(url, title, shareEnabled);
        }
    }

    /**
     * 存储
     */
    function Storage(wrapper) {

        /**
         * 保存数据
         */
        this.setItem = function(key, value) {
            wrapper.setItem(key, value);
        }

        /**
         * 获取数据
         */
        this.getItem = function(key) {
            return wrapper.getItem(key);
        }

        /**
         * 移除数据
         */
         this.removeItem = function(key) {
            wrapper.removeItem(key);
         }

        /**
         * 清除缓存
         */
        this.clearCache = function(callback) {
            window.clearCacheCallback = function(res) {
                window.clearCacheCallback = null;
                callback(res);
            };
            wrapper.clearCache("clearCacheCallback");
        }

        /**
         * 获取缓存大小
         */
        this.getCacheSize = function() {
            return wrapper.getCacheSize();
        }
    }

    /**
     * 其他组件
     */
    function Util(wrapper) {

        /**
         * 拨打电话
         */
        this.callPhone = function(phone) {
            wrapper.callPhone(phone);
        }

        /**
         * 复制文本
         */
        this.copy = function(text) {
            wrapper.copy(text);
        }

        /**
         * 记录日志
         */
        this.log = function(text) {
            wrapper.log(text);
        }

        /**
         * 是否支持生物识别 返回bool类型
         */
        this.isSupportBiometric = function() {
            return wrapper.isSupportBiometric();
        }
        /**
         * 是否设置生物识别 返回bool类型
         */
        this.isBiometricEnable = function() {
            return wrapper.isBiometricEnable();
        }
        /**
         * 是否设置手势登录 返回bool类型
         */
        this.isEnabledGesture = function() {
            return wrapper.isEnabledGesture();
        }
        /**
         * 设置手势开关
         * @param {boolean} enable 是否开启
         */
        this.setGestureEnable = function(enable, callback) {
            wrapper.setGestureEnable(enable, "nativeGestureCallback", callback);
        }
        /**
         * 设置生物识别开关
         * @param {boolean} enable 是否开启
         */
        this.setBiometricEnable = function(enable, callback) {
            var cbName = 'nativeBiometricCallback'
            window[cbName] = function(flag) {
                window[cbName] = null;
                callback(flag);
            };
            wrapper.setBiometricEnable(enable, cbName);
        }
        /**
         * 修改手势密码
         */
        this.gestureModify = function() {
            wrapper.gestureModify();
        }
        /**
         * 属性埋点
         */
        this.tdPropertyPoint = function(eventId, eventLabel) {
            wrapper.tdPropertyPoint(eventId, eventLabel);
        }
        /**
         * 事件埋点
         */
        this.tdEventPoint = function(eventId, eventLabel) {
            wrapper.tdEventPoint(eventId, eventLabel);
        }
    }

    /**
     * 业务相关功能
     */
    function Business(wrapper) {

        /**
         * 登录
         * 回调的code，0：成功；1：取消
         * json：后台返回的数据，json对象
         */
        this.login = function(callback) {
            // window.nativeLoginCallback = function(code, json) {
            //     window.nativeLoginCallback = null;
            //     callback(code, json);
            // };
            wrapper.login("nativeLoginCallback");
        }

        /**
         * 退出登录
         */
        this.logout = function() {
            wrapper.logout();
        }

        /**
         * 分享
         */
        this.share = function(url, title, description) {
            wrapper.share(url, title, description);
        }

        /**
         * RSA加密
         */
        this.rsa = function(text) {
            return wrapper.rsa(text);
        }

        /**
         * AES加密
         */
        this.aes = function(text) {
            return wrapper.aes(text);
        }

        /**
         * 显示或隐藏悬浮按钮
         */
        this.suspensionView = function (isShow) {
            wrapper.suspensionView(isShow);
        }

        /**
         * 拖动验证码匹配成功回调
         */
        this.validationSuccess = function (data) {
            wrapper.validationSuccess(data);
        }
    }

    function Native() {
        var wrapper;
        if (typeof android != 'undefined') {
            wrapper = new Android();
        } else {
            wrapper = new iOSWKWebView();
        }

        this.ui = new UI(wrapper);
        this.net = new Net(wrapper);
        this.file = new File(wrapper);
        this.util = new Util(wrapper);
        this.storage = new Storage(wrapper);
        this.business = new Business(wrapper);
    }
    window.native = new Native();

})(window);
